# Why use AppBlocks?

Most modern front-end libraries/frameworks such as Vue, React and Angular are well-suited for building complex, scalable
and maintainable applications if you know how to use them. There is no doubt these are battle tested, production-ready
libraries/frameworks.

So you probably want to know where AppBlocks shines and how it can help you in developing your front-end more efficiently.

## The AppBlocks use case:

- **Micro-Frontends:** For implementing micro-frontend architectures where different teams might be working on different parts of a web application, AppBlocks can serve as a lightweight solution for smaller parts without needing the whole app to use the same framework.

- **Simple Interactive Websites:** For websites that need a sprinkle of interactivity (like form validations, toggles, simple data displays) without the overhead of a full framework.

- **Enhancing Static Pages:** Perfect for adding interactivity to otherwise static HTML/CSS pages, especially when you don't want to refactor the whole site into a single-page application (SPA).

- **Legacy System Enhancements:** When you're dealing with a legacy system that might be difficult or risky to fully refactor, injecting AppBlocks to add or improve features can be a safer, incremental approach.

- **Server-Side Rendered (SSR) Websites:** For enhancing pages that are primarily server-rendered but could benefit from a bit of client-side dynamism without going full SPA.

- **Rapid Prototyping:** When you need to quickly mock up web apps or features without setting up a complex build environment. AppBlocks can be a go-to for developers looking to iterate fast.

- **Embeddable Widgets:** For creating widgets that can be easily embedded into existing pages or platforms, such as dashboards, without needing to worry about framework compatibility.

- **SEO-Focused Projects:** Since it's designed to enhance web pages rather than control the entire front-end, it's likely to be more search engine friendly out of the box for pages that require minimal interactivity. That is also the main reason why AppBlocks update real DOM trees instead of using a virtual DOM.

- **Performance-Sensitive Applications:** In scenarios where every kilobyte matters, AppBlocks' lightweight nature means faster load times, which is crucial for performance-sensitive environments like mobile web.